All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PQueueChannel Class Reference

Class for implementing a serial queue channel in memory. More...

`#include <qchannel.h>`

Inheritance diagram for PQueueChannel:

## Public Member Functions

Construction
| PQueueChannel (PINDEX queueSize=0)
| Create a new queue channel with the specified maximum size. More...
| ~PQueueChannel ()
| Delete queue and release memory used. More...
Overrides from class PChannel
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the file channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the file channel. More...
virtual PBoolean | Close ()
| Close the file channel. More...
Queue manipulation functions
virtual PBoolean | Open (PINDEX queueSize)
| Open a queue, allocating the queueSize bytes. More...
PINDEX | GetSize () const
| Get the queue size. More...
PINDEX | GetLength () const
| Get the current queue length. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two strings. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open. More...
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

PMutex | mutex
BYTE * | queueBuffer
PINDEX | queueSize
PINDEX | queueLength
PINDEX | enqueuePos
PINDEX | dequeuePos
PSyncPoint | unempty
PSyncPoint | unfull
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Additional Inherited Members

Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Detailed Description

Class for implementing a serial queue channel in memory.

This implements a simple memory based First In First Out queue. Data written to an instance of the class may be read from the same instance at some later time.

The queue will block the read for the Read Timeout if the queue is empty. Similarly a write will be clocked for Write Timeout if the queue is full.

If there is any data to be read then it returns immediately with those bytes, so you must check the GetLastReadCount() to determine the actual number of bytes read and not rely on the count being passed into the read function.

## Constructor & Destructor Documentation

PQueueChannel::PQueueChannel | ( | PINDEX | queueSize = `0` | ) |

Create a new queue channel with the specified maximum size.

Parameters

  queueSize | Queue size

PQueueChannel::~PQueueChannel | ( |  | ) |

Delete queue and release memory used.

## Member Function Documentation

virtual PBoolean PQueueChannel::Close | ( |  | ) |

virtual

Close the file channel.

Returns
  true if close was OK.

Reimplemented from PChannel.

PINDEX PQueueChannel::GetLength | ( |  | ) | const

inline

Get the current queue length.

References queueLength.

PINDEX PQueueChannel::GetSize | ( |  | ) | const

inline

Get the queue size.

References queueSize.

virtual PBoolean PQueueChannel::Open | ( | PINDEX | queueSize | ) |

virtual

Open a queue, allocating the queueSize bytes.

Parameters

  queueSize | Queue size

virtual PBoolean PQueueChannel::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level read from the file channel.

The read timeout is ignored for file I/O. The GetLastReadCount() function returns the actual number of bytes read.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Parameters

  buf | Pointer to a block of memory to receive the read bytes.
  len | Maximum number of bytes to read into the buffer.

Reimplemented from PChannel.

virtual PBoolean PQueueChannel::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level write to the file channel.

The write timeout is ignored for file I/O. The GetLastWriteCount() function returns the actual number of bytes written.

The GetErrorCode() function should be consulted after Write() returns false to determine what caused the failure.

Returns
  true if at least len bytes were written to the channel.

Parameters

  buf | Pointer to a block of memory to write.
  len | Number of bytes to write.

Reimplemented from PChannel.

## Member Data Documentation

PINDEX PQueueChannel::dequeuePos

protected

PINDEX PQueueChannel::enqueuePos

protected

PMutex PQueueChannel::mutex

protected

BYTE* PQueueChannel::queueBuffer

protected

PINDEX PQueueChannel::queueLength

protected

Referenced by GetLength().

PINDEX PQueueChannel::queueSize

protected

Referenced by GetSize().

PSyncPoint PQueueChannel::unempty

protected

PSyncPoint PQueueChannel::unfull

protected

The documentation for this class was generated from the following file:

- qchannel.h